Index: resources/styles/default/lines
===================================================================
--- resources/styles/default/lines	(revision 3792)
+++ resources/styles/default/lines	(working copy)
@@ -76,13 +76,16 @@
 highway=secondary | highway=tertiary {name '${ref|highway-symbol:oval} ${name}' | '${ref|highway-symbol:oval}' | '${name}'; addlabel '${name} (${ref})' }
 highway=* {name '${name}' | '${ref}' }
 
+# Flag paved roads
+highway=* & (surface=asphalt | surface=paved | surface=sett | 
+    surface=concrete | surface=concrete:lanes | surface=concrete:plates | 
+    surface=paving_stones  | surface=cobblestone  | 
+   	surface=cobblestone:flattened  | surface=metal  | surface=wood) 
+{ set mkgmap:unpaved=0 }
+   
 # Flag unpaved roads.
-highway=*
-& (surface=cobblestone | surface=compacted | surface=dirt |
-   surface=earth | surface=grass | surface=grass_paver |
-   surface=gravel | surface=grit | surface=ground | surface=mud |
-   surface=pebblestone | surface=sand | surface=unpaved |
-   mtb:scale=* |
+highway=* & mkgmap:unpaved!=0 &
+(  mtb:scale=* |
    tracktype ~ 'grade[2-6]' |
    smoothness ~ '.*(bad|horrible|impassable)' |
    sac_scale ~ '.*(mountain|alpine)_hiking' |
